run-tests.sh 2.35 KB
Newer Older
Daniel Barlow's avatar
Daniel Barlow committed
1 2
#!/bin/sh

3
# do_tests {lisp invocation} {scripts-regex}
4 5 6 7
# - read lisp forms one at a time from standard input
# - quit with exit status 0 on getting eof
# - quit with exit status >0 if an unhandled error occurs

8

9 10 11 12 13 14 15 16 17 18
if [ x"$1" = "xhelp" ]; then
    echo "$0 [lisp invocation] [scripts-regex]"
    echo " - read lisp forms one at a time from matching scripts"
    echo " - quit with exit status 0 on getting eof"
    echo " - quit with exit status >0 if an unhandled error occurs"
    echo " you need to supply the .script in the second argument"
    echo " lisps include sbcl, clisp, allegro and allegromodern"
    exit -1
fi

19 20 21
if [ -z "$2" ]; then
    scripts="*.script"
else
22
    scripts="$2"
23 24
fi

25 26
sok=1

27
do_tests() {
28
rm -f *.$2 || true
29 30 31 32 33 34
( cd .. && echo '(load "test/compile-asdf.lisp")' | $1  )
if [ $? -eq 0 ] ; then
    test_count=0
    test_pass=0
    test_fail=0
    failed_list=""
35
    for i in $scripts ; 
36 37 38
    do 
      echo "Testing: $i" >&2
      test_count=`expr "$test_count" + 1`
39
      rm -f *.$2 || true
40
      if  $1 < $i ; then
41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60
        echo "Using $1, $i passed" >&2
	test_pass=`expr "$test_pass" + 1`
      else
        echo "Using $1, $i failed" >&2
	test_fail=`expr "$test_fail" + 1`
	failed_list="$failed_list $i"
        sok=0
      fi
    done
    echo >&2
    echo "Using $1" >&2
    echo "Ran $test_count tests: " >&2
    echo "  $test_pass passing and $test_fail failing" >&2
    if [ $test_fail -eq 0 ] ; then
	echo "all tests apparently successful" >&2
    else
	echo "failing test(s): $failed_list" >&2
    fi
    echo >&2
fi
61 62
}

63
# terminate on error
64 65
set -e

66 67 68
lisp=$1
if [ -z $1 ] ; then
    lisp="sbcl"
69 70
fi

71 72 73 74 75 76 77 78
if [ "$lisp" = "sbcl" ] ; then 
    if type sbcl ; then
      fasl_ext="fasl"
      command="sbcl --userinit /dev/null --sysinit /dev/null --noprogrammer"
    fi
elif [ "$lisp" = "clisp" ] ; then
    if type clisp ; then
	fasl_ext="fas"
79
	command=`which clisp`
80 81 82 83 84 85 86
	command="$command -norc -ansi -I - "
    fi
elif [ "$lisp" = "allegro" ] ; then
    if type alisp ; then
	fasl_ext="fasl"
	command="alisp -q --batch "
    fi
87 88 89 90 91
elif [ "$lisp" = "allegromodern" ] ; then
    if type mlisp ; then
	fasl_ext="fasl"
	command="mlisp -q --batch "
    fi
92 93
fi

94 95 96 97 98 99 100 101 102 103 104 105

#if [ -x /usr/bin/lisp ]
#then 
#  do_tests "/usr/bin/lisp -batch -noinit" x86f
#fi


if [ -z "$command" ] ; then
    echo "Error: don't know how to run Lisp named $lisp"
else
    echo $command
    do_tests "$command" $fasl_ext
106
fi
107